/*
========================================================================
 Name        : DiskDetector.cpp
 Author      : chenziteng@163.com
 Copyright   : Your copyright notice
 Description : 
========================================================================
*/

#include "DiskDetector.h"    
   
CDiskDetector* CDiskDetector::NewL(MObserver& aObserver, RFs& aFs)   
    {   
    CDiskDetector* self = new (ELeave) CDiskDetector(aObserver, aFs);   
    CleanupStack::PushL(self);   
    self->ConstructL();   
    CleanupStack::Pop();   
    return self;   
    }   
   
CDiskDetector::~CDiskDetector()   
    {   
    Cancel();   
    }   
   
void CDiskDetector::Start()   
    {   
    Cancel();   
    iFs.NotifyChange(ENotifyDisk, iStatus);   
    SetActive();   
    }   
   
void CDiskDetector::RunL()   
    {   
    TInt err = iStatus.Int();   
    if(err!=KErrCancel)   
        {   
        iObserver.NotifyDiskChange();
        }   
    }   
   
void CDiskDetector::DoCancel()   
    {   
    iFs.NotifyChangeCancel();   
    }   
   
CDiskDetector::CDiskDetector(MObserver& aObserver, RFs& aFs)   
    : CActive(CActive::EPriorityStandard), iObserver(aObserver), iFs(aFs)   
    {   
    }   
   
void CDiskDetector::ConstructL()   
    {   
    CActiveScheduler::Add(this);   
    }   
