#if !defined(__CMyDolbyHeadphone_H__)
#define __CMyDolbyHeadphone_H__

#include <e32base.h>

class CAudioEffect;
class CMdaAudioPlayerUtility;
class CMdaAudioOutputStream;

#include <MAudioEffectObserver.h>

class MMyDolbyHeadphoneObserver
{
public:
  virtual void DolbyChange(TBool aState)=0;
};


typedef void (* TRegisterObserverL)( CAudioEffect* aDolbyObj, MAudioEffectObserver& aObserver );
typedef void (* TUnRegisterObserver)( CAudioEffect* aDolbyObj, MAudioEffectObserver& aObserver );


typedef CAudioEffect* (* TDolbyHeadphoneNewL14)(CMdaAudioOutputStream& aAudioOutput);
typedef CAudioEffect* (* TDolbyHeadphoneNewL15)(CMdaAudioPlayerUtility& aPlayer);

class CMyDolbyHeadphone : public CBase,
                          public MAudioEffectObserver
{
public:

  static CMyDolbyHeadphone* NewL(MMyDolbyHeadphoneObserver& aObs);

  virtual ~CMyDolbyHeadphone();

  void DolbyOnL(TBool aOn);

  void CreateDolby1L(CMdaAudioPlayerUtility& aPlayer);
  void CreateDolby2L(CMdaAudioOutputStream& aAudioOutput);

  void DestroyDolby();

  TBool IsCreated();

private:
  CMyDolbyHeadphone(MMyDolbyHeadphoneObserver& aObs);

  void ConstructL();

  //MAudioEffectObserver
  void EffectChanged( const CAudioEffect* aObservedEffect, TUint8 aEvent );

private:

  RLibrary DolbyHeadphoneLib;
  RLibrary EffectBaseLib;

  CAudioEffect* iDolbyObj;

  TRegisterObserverL  iRegisterObs;
  TUnRegisterObserver iUnRegisterObs;

  TDolbyHeadphoneNewL15 Dolby15;
  TDolbyHeadphoneNewL14 Dolby14;

  MMyDolbyHeadphoneObserver& iObs;
  TBool iOn;

  TBool iCreated;
};

#endif // !defined(__CMyDolbyHeadphone_H__)
