#ifndef C_CREMCONKEYRESPONSE_H
#define C_CREMCONKEYRESPONSE_H


// INCLUDE FILES
#include <remconcoreapitarget.h>


// CLASS DECLARATION

/**
 *  Helper class for sending response back to 
 *  Remote Controller Framework.
 *  All events must be completed.
 */
class CRemConKeyResponse : public CActive
{
public:
        
    static CRemConKeyResponse* NewL( CRemConCoreApiTarget& aRemConCoreApiTarget);
        
    virtual ~CRemConKeyResponse();
   
    /**
     * Send the any key response back to Remcon server
     * @param aOperationId RemCon operation Id.
     */
    void CompleteAnyKey( TRemConCoreApiOperationId aOperationId );
    
private:

    CRemConKeyResponse( CRemConCoreApiTarget& aRemConCoreApiTarget );

// from base class CActive

    void RunL();
    void DoCancel();

private:    // Data

    /**
     * Response array.
     * Own.
     */
    RArray<TRemConCoreApiOperationId> iResponseArray;
    
    /**
     * Remote controller.
     * Not own.
     */
    CRemConCoreApiTarget& iRemConCoreApiTarget;
}; 

#endif  // C_CREMCONKEYRESPONSE_H

// End of File
