/*

libdemac - A Monkey's Audio decoder

$Id: demac_config.h 29239 2011-02-06 23:18:30Z amiconn $

Copyright (C) Dave Chapman 2007

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

*/

#ifndef _DEMAC_CONFIG_H
#define _DEMAC_CONFIG_H

/* Build-time choices for libdemac.
 * Note that this file is included by both .c and .S files. */

#define APE_OUTPUT_DEPTH (ape_ctx->bps)

/* Use to give gcc hints on which branch is most likely taken */
#if defined(__GNUC__) && __GNUC__ >= 3
#define LIKELY(x)   __builtin_expect(!!(x), 1)
#define UNLIKELY(x) __builtin_expect(!!(x), 0)
#else
#define LIKELY(x)   (x)
#define UNLIKELY(x) (x)
#endif

/* Defaults */

#ifndef FILTER_HISTORY_SIZE
#define FILTER_HISTORY_SIZE 512
#endif

#ifndef PREDICTOR_HISTORY_SIZE
#define PREDICTOR_HISTORY_SIZE 512
#endif     

typedef unsigned char uint8_t;
typedef unsigned short uint16_t;

//typedef int int32_t;
#include <e32def.h>
typedef TInt32			int32_t;

typedef unsigned long int uint32_t;
typedef short int int16_t;
typedef long long int64_t;

#define intptr_t    long
#define uintptr_t   unsigned long

#ifndef FILTER_BITS
#define FILTER_BITS 16
typedef int16_t filter_int;
#endif


#endif /* _DEMAC_CONFIG_H */
